Unit IA11R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IA10R1_p, IAC1R1_p, IAS1R2_p;

procedure IA11R(FUNXY :Func_F4; AX :Real; BX :Real; AY :Real;
                BY :Real; EPS :Real; LX :Integer; LY :Integer;
                IDX :Integer; IDY :Integer; JX :Integer;
                JY :Integer; var NX :Integer; var NY :Integer;
                var TX :Array of Real; var TY :Array of Real;
                var CXY :Array of Real; NCX :Integer; NCY :Integer;
                var CX :Array of Real; var CY :Array of Real);

implementation

procedure IA11R(FUNXY :Func_F4; AX :Real; BX :Real; AY :Real;
                BY :Real; EPS :Real; LX :Integer; LY :Integer;
                IDX :Integer; IDY :Integer; JX :Integer;
                JY :Integer; var NX :Integer; var NY :Integer;
                var TX :Array of Real; var TY :Array of Real;
                var CXY :Array of Real; NCX :Integer; NCY :Integer;
                var CX :Array of Real; var CY :Array of Real);
var
I,J,K,KX,KY,L,M,N,N1,N2,N3,N4,N5,N6 :Integer;
D :Real;
A :Array [0..5] of Real;
B :Array [0..5] of Real;
C :Array [0..5] of Real;
const
C0 :Real = 0.0;
K0 :Integer = 0;
K1 :Integer = 1;
K2 :Integer = 2;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170;
begin
KX  := K2*(LX + K2);
KY  := K2*(LY + K2);
I  := NX + K2*(KX - K2);
D  := (BX - AX)/(NX - K1);
for J:=K1 to I do
 begin
  TX[J-1] := AX + (J - KX + K1)*D;
_10:
 end;
J  := NY + K2*(KY - K2);
D  := (BY - AY)/(NY - K1);
M  := NX + KX - K2;
N1  := LX + K1;
for L:=K1 to J do
 begin
  TY[L-1] := AY + (L - KY + K1)*D;
  for K:=K1 to I do
   begin
    CX[K-1] := FUNXY(TX[K-1],TY[L-1]);
_20:
   end;
  for K:=K1 to M do
   begin
    N  := N1 + K;
    CXY[(K-1)+(L-1)*NCX] := IAC1R1(TX,CX,N1,N);
_30:
   end;
_40:
 end;
N  := NY + KY - K2;
N1  := LY + K1;
for K:=K1 to M do
 begin
  for L:=K1 to J do
   begin
    CY[L-1] := CXY[(K-1)+(L-1)*NCX];
_50:
   end;
  for L:=K1 to N do
   begin
    I  := N1 + L;
    CXY[(K-1)+(L-1)*NCX] := IAC1R1(TY,CY,N1,I);
_60:
   end;
  CX[K-1] := C0;
_70:
 end;
N1  := KX - K2;
N2  := KY - K2;
for I:=K1 to NY do
 begin
  CY[I-1] := C0;
  K  := I;
  if ( I  =  NY ) 
   then K  := K - K1;
  N3  := I + N1;
  N4  := K + N1;
  for J:=K1 to NX do
   begin
    L  := J;
    if ( J  =  NX ) 
     then L  := L - K1;
    for M:=K1 to KX do
     begin
      N5  := L + M - K1;
      for N:=K1 to KY do
       begin
        N6  := K + N - K1;
        A[N-1] := CXY[(N5-1)+(N6-1)*NCX];
_80:
       end;
      B[M-1] := IAS1R2(TY,A,KY,IDY,TY[N3-1],N4,K0);
      C[M-1] := IAS1R2(TY,A,KY,N2,TY[N3-1],N4,K0);
_90:
     end;
    N5  := J + N1;
    N6  := L + N1;
    D  := IAS1R2(TX,B,KX,N1,TX[N5-1],N6,K0);
    if ( D  <  C0 ) 
     then D  := C0 - D;
    if ( D  >  CX[J-1] ) 
     then CX[J-1] := D;
    D  := IAS1R2(TX,C,KX,IDX,TX[N5-1],N6,K0);
    if ( D  <  C0 ) 
     then D  := C0 - D;
    if ( D  >  CY[I-1] ) 
     then CY[I-1] := D;
_100:
   end;
_110:
 end;
D  := EPS/K2;
K  := NCX - K2*K2;
IA10R1(CX,NX,AX,BX,D,K,KX,IDX,JX,TX);
K  := NCY - K2*K2;
IA10R1(CY,NY,AY,BY,D,K,KY,IDY,JY,TY);
K  := NX + K2;
I  := K + K2;
J  := I - NX + NY;
for L:=K1 to J do
 begin
  for M:=K1 to I do
   begin
    CX[M-1] := FUNXY(TX[M-1],TY[L-1]);
_120:
   end;
  for M:=K1 to K do
   begin
    N  := M + K1;
    CXY[(M-1)+(L-1)*NCX] := IAC1R1(TX,CX,LX,N);
_130:
   end;
_140:
 end;
I  := J - K2;
for L:=K1 to K do
 begin
  for M:=K1 to J do
   begin
    CY[M-1] := CXY[(L-1)+(M-1)*NCX];
_150:
   end;
  for M:=K1 to I do
   begin
    N  := M + K1;
    CXY[(L-1)+(M-1)*NCX] := IAC1R1(TY,CY,LX,N);
_160:
   end;
_170:
 end;
end;

end.
